<template>
  <div>
    <div class="row">
      <div class="col-xs-12">
        <control-group
          v-model="group"
          :items="groupItems"
          theme="light"
        />
      </div>
    </div>
    <component
      :is="currentComponent"
      :fromLocations="fromLocations"
      :toLocations="toLocations"
      :type="type"
      @setLocations="setLocations"
      @setType="setType"
    />
  </div>
</template>

<script>
  import ControlGroup from 'common-components/src/obComponents/obControlGroup'
  import SubscriptionModalLocationsPoints from './SubscriptionModalLocationsPoints';
  import SubscriptionModalLocationsFromTo from './SubscriptionModalLocationsFromTo';

  export default {
    name: 'SubscriptionModalLocations',
    components: {
      ControlGroup
    },
    props: {
      fromLocations: {
        type: Object,
        required: true,
      },
      toLocations: {
        type: Object,
        required: true,
      },
      type: {
        type: String,
        required: true
      }
    },
    data() {
      return {
        selected: '',
        groupItems: [
          {
            label: 'По точкам отгрузки',
            value: 'SHIPMENT_POINTS',
            component: SubscriptionModalLocationsPoints
          },
          {
            label: 'Откуда/Куда',
            value: 'FROM_TO_BACKWARD',
            component: SubscriptionModalLocationsFromTo
          }
        ]
      };
    },
    computed: {
      group: {
        get () {
          return this.type
        },
        set (data) {
          this.$emit('setType', data)
        }

      },
      currentComponent () {
        if (this.type === 'SHIPMENT_POINTS') return SubscriptionModalLocationsPoints

        return SubscriptionModalLocationsFromTo
      }
    },
    methods: {
      setLocations (event, direction, isAll) {
        this.$emit('setLocations', event, direction, isAll)
      },
      setType (event) {
        this.$emit('setType', event)
      },
    }
  };
</script>